/* Quelques macros et structures de base
 * Auteur : Fares BELHADJ (Lire COPYING)
 * Email  : amsi@ai.univ-paris8.fr
 * Date   : 03/01/2008
 */
#ifndef _ASTDLIB_H

#define _ASTDLIB_H

#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) > (b)) ? (a) : (b))

/* Calcule un nombre pseudo-aleatoire dans l'intervalle [0, 1[. Ici la
 * distribution est uniforme.
 */
#define u_rand() (rand() / (RAND_MAX + 1.0))
/* Calcule un nombre pseudo-aleatoire dans l'intervalle [-1, 1[. Ici
 * la distribution est uniforme.
 */
#define su_rand() (2.0 * (rand() / (RAND_MAX + 1.0)) - 1.0)

typedef struct vector3f_t  vector3f_t;
typedef struct vector3f_t  point3f_t;

struct vector3f_t {
  float x, y, z;
};

struct color4f_t {
  float r, g, b, a;
};

#endif
